C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      SUBROUTINE GETDATE(ID,IM,IY,IH,IMIN,THOURS)
C
C     THIS ROUTINE GIVES THE DAY, MON, YEAR, HOUR AND MINUTES 
C     CORRESPONDING TO THE GIVEN HOURS
C
C  OSSM01.FOR
C
      COMMON /DEVCES/ LPRT,LCON,LTPE,LDSK,LWCON
      DIMENSION MON(12,2)
      DIMENSION LYEAR(4)
      DATA(LYEAR(I),I=1,4)/8784,8760,8760,8760/
      DATA (MON(I,1),I=1,12)/0,31,59,90,120,151,181,212,243,273,
     C304,334/
      DATA (MON(I,2),I=1,12)/0,31,60,91,121,152,182,213,244,274,
     C305,335/
      THOURS=THOURS+.00417
      XHOURS=MOD(THOURS,24.0)
      IH=INT(XHOURS)
      IMIN=INT((XHOURS-FLOAT(IH))*60.)
      IHOURS=INT(THOURS-XHOURS+.001)
      IY=0
      YDSUM=0
 5    CONTINUE
      DO 10 I=1,4
      YDSUM=YDSUM+LYEAR(I)
      IY=IY+1
      IF(YDSUM.GT.IHOURS) GOTO 75
      IF(YDSUM.EQ.IHOURS) GOTO 85
 10   CONTINUE
      GOTO 5
 75   YDSUM=YDSUM-LYEAR(I)
      IY=IY-1
  85   IF(I.EQ.1) GOTO 200
      GOTO 100
 100  CONTINUE
      K=1
 110  IDAYS=(IHOURS-YDSUM)/24+1
      DO 120 JFLAG=1,12
      IF(MON(JFLAG,K).GE.IDAYS) GOTO 130
 120  CONTINUE
      IM=12
      ID=IDAYS-MON(12,K)
      GOTO 999
 130  ID=IDAYS-MON(JFLAG-1,K)
      IM=JFLAG-1
      GOTO 999
 200  K=2
      GOTO 110
 999  CONTINUE
      THOURS=THOURS-.00417
c change year from 2 digitis to 4 digits (hli,03/28/2000)
      IY=IY+1900
      RETURN
      END
