C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      SUBROUTINE PCLAMP
C     VERSION(12/31/98)
CNG     VERSION(10/05/11) WITH GRAV, AVERAGED H + EL, CORRECTED ORLANSKI AND SIMPLIFIED
C
      INCLUDE 'comdeck'
C
C  MODIFIED BY Quamrul QA 12/31/98 
C
        DO 100 N = 1, NUMEBC
        IE = IETA(N)
        JE = JETA(N)
        IC = ICON(N)
        JC = JCON(N)
C
C --- NORTH OR SOUTH BOUNDARY (RADIATION & FORCING) --------------------
C
      IF (IE.EQ.IC) Then
        CPH=SQRT(GRAV*0.5*(H(IE,JE)+EL(IE,JE)+H(IC,JC)+EL(IC,JC)))*2.
     .      *DTE/(H2(IE,JE)+H2(IC,JC))
C
C --- EAST OR WEST BOUNDARY (RADIATION & FORCING) --------------------
C
      ELSE
        CPH=SQRT(GRAV*0.5*(H(IE,JE)+EL(IE,JE)+H(IC,JC)+EL(IC,JC)))*2.
     .      *DTE/(H1(IE,JE)+H1(IC,JC))
      ENDIF
CNG-ORLANSKI-IMPLICIT      ELF(IE,JE)=(ELB(IE,JE)+CPH*(2.*EL(IC,JC)-ELB(IC,JC))+2.*DTE*
      ELF(IE,JE)=(ELB(IE,JE)+CPH*(2.*EL(IC,JC)-ELB(IE,JE))+2.*DTE*
     .           (ELF(IE,JE)-ELB(IE,JE))*TLAG)/(1.+CPH)
 100  CONTINUE
C
      RETURN
      END
