C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      SUBROUTINE PRINT(VAR,VMASK,IM,JM,IVAR,S,IUNIT,DEV)
C     VERSION(05/24/91)
C
      SAVE
      CHARACTER*3 DEV
      DIMENSION VAR(IM,JM),IVAR(IM,JM),VMASK(IM,JM)
      DO 100 J=1,JM
      DO 100 I=1,IM
CNG  100 IVAR(I,J)=NINT(S*VAR(I,J))
  100 IVAR(I,J)=NINT(S*VAR(I,J)*VMASK(I,J)) ! CNG01052010, 0 OUT PERMANENTLY DRY
      CALL MAXMIN(VAR,VMASK,IM,JM,VMAX,VMIN)
      IF(DEV.EQ.'LPR') THEN
       KN=20
      ELSE
       KN=10
      ENDIF
      IB=1
      IE=KN
      NUM=(IM-1)/KN
      IF(IM.LE.KN) NUM=1
      IF(IM.LE.KN) IE=IM
      DO 200 K=1,NUM
      IF(K.EQ.1) WRITE(IUNIT,110) S,VMAX,VMIN
  110 FORMAT(//2X,'ACTUAL VALUE = PRINTED VALUE/',1PE9.2,
     .      5X,'MAX VALUE = ',1PE9.2,2X,'MIN VALUE = ',1PE9.2)
      IF(DEV.EQ.'LPR') THEN
       WRITE(IUNIT,120) (I,I=IB,IE)
      ELSE
       WRITE(IUNIT,121) (I,I=IB,IE)
      ENDIF
  120 FORMAT(//10X,20I5)
  121 FORMAT(//10X,10I5)
      WRITE(IUNIT,130)
  130 FORMAT(/)
      DO 150 J=1,JM
      JJ=JM+1-J
      IF(DEV.EQ.'LPR') THEN
       WRITE(IUNIT,140) JJ,(IVAR(I,JJ),I=IB,IE),JJ
      ELSE
       WRITE(IUNIT,141) JJ,(IVAR(I,JJ),I=IB,IE),JJ
      ENDIF
  140 FORMAT(' ',I8,1X,20I5,1X,I8,' ')  
  141 FORMAT(' ',I8,1X,10I5,1X,I8,' ')   
  150 CONTINUE
      IB=IB+KN
      IE=IE+KN
  200 CONTINUE
      IF(IM.LE.KN) GO TO 300
      IE=IM
      IF(DEV.EQ.'LPR') THEN
       WRITE(IUNIT,120) (I,I=IB,IE)
      ELSE
       WRITE(IUNIT,121) (I,I=IB,IE)
      ENDIF
      WRITE(IUNIT,130)
      DO 250 J=1,JM
      JJ=JM+1-J
      IF(DEV.EQ.'LPR') THEN
       WRITE(IUNIT,140) JJ,(IVAR(I,JJ),I=IB,IE),JJ
      ELSE
       WRITE(IUNIT,141) JJ,(IVAR(I,JJ),I=IB,IE),JJ
      ENDIF
  250 CONTINUE
  300 RETURN
      END
