C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      SUBROUTINE RANDB
      INCLUDE 'comdeck'
      DO 1000 N = 1, NUMEBC
        IE = IETA(N)
        JE = JETA(N)
        IC = ICON(N)
        JC = JCON(N)
        If (FSM(IE+1,JE).EQ.0.0.AND.JE.EQ.JC) Then
c right
          DEPTH=(D(IE,JE)+D(IC,JC))/2.
          UAF(IE,JE)=SQRT(GRAV/DEPTH)*(EL(IC,JC)-EL(IE,JE))
        Else If (FSM(IE-1,JE).EQ.0.0.AND.JE.EQ.JC) Then
c left
          DEPTH=(D(IE,JE)+D(IC,JC))/2.
          UAF(IC,JC)=-SQRT(GRAV/DEPTH)*(EL(IC,JC)-EL(IE,JE))
        Else If (FSM(IE,JE+1).EQ.0.0.AND.IE.EQ.IC) Then
c top
          DEPTH=(D(IC,JC)+D(IE,JE))/2.
c         DEPTH=(h(IC,JC)+h(IE,JE))/2.
          VAF(IE,JE)=SQRT(GRAV/DEPTH)*(EL(IC,JC)-EL(IE,JE))
        Else If (FSM(IE,JE-1).EQ.0.0.AND.IE.EQ.IC) Then
c bottom
          DEPTH=(D(IC,JC)+D(IE,JE))/2.
          VAF(IC,JC)=-SQRT(GRAV/DEPTH)*(EL(IC,JC)-EL(IE,JE))
        End If
1000  CONTINUE
      RETURN
      END
