C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      SUBROUTINE UPDATE_CBCM
CNG2014 This version if for barotropic only with Manning's n.
      INCLUDE 'comdeck'
      SAVE

      Do 6030 J = 1, JM
        Do 6020 I = 1, IM
          If (FSM(I,J).NE.0.0) Then
              CBCMIN = BFRIC
              CBC(I,J)=AMAX1(CBCMIN,GRAV*VARMN(I,J)*VARMN(I,J)/
     +                  (AMAX1(DT(I,J),WETMIN)**(1./3.)))
          Else
           CBC(I,J)=BFRIC !Initialize CBC even at FSM=0 cells
          END IF
          CBC(I,J) = AMIN1(CBC(I,J),1.) ! DO NOT ALLOW CBC TO EXCEED UNITY.
 6020   CONTINUE
 6030 CONTINUE

      RETURN
      END
