C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      SUBROUTINE FZOL(ZOL,PHIM,PHIG,PSIM,PSIG)
C FZOL:    SUBROUTINE TO ESTIMATE THE STABILITY FUNCTIONS
CMNT       USING THE MOST UP TO DATE FLUX-PROFILE RELATIONSHIPS
CMNT
      IF (ZOL .GE. 0.0) GO TO 2
CMNT             UNSTABLE
      X=(1.0-16.0*ZOL)**0.25
      PHIM=1.0/X
      PHIG=PHIM**2
      PSIG=2.0*ALOG(0.5+0.5*X**2)
      PSIM=0.5*PSIG+2.0*ALOG(0.5*(1.0+X))-2.0*ATAN(X)+1.571
      RETURN
CMNT
CMNT     STABLE
2     PHIG=1.0+7.0*ZOL
      PHIM=1.0+7.0*ZOL
      PSIG=-7.0*ZOL
      PSIM=-7.0*ZOL
      RETURN
      END          
