C **********************************************************************
C *                                                                    *
C *                                SOFTWARE LICENSING                  *
C *                                                                    *
C *                This program is free software; you can redistribute *
C *                it and/or modify it under the terms of the GNU      *
C *                General Public License as published by the Free     *
C *                Software Foundation, either Version 2 of the        *
C *                license, or (at your option) any later version.     *
C *                                                                    *
C *                This program is distributed in the hope that it     *
C *                will be useful, but without any warranty; without   *
C *                even the implied warranty of merchantability or     *
C *                fitness for a particular purpose. See the GNU       *
C *                General Public License for more details.            *
C *                                                                    *
C *                A copy of the GNU General Public License is         *
C *                available at http://www.gnu.org/copyleft/gpl.html   *
C *                or by writing to the Free Software Foundation, Inc.,*
C *                59 Temple Place - Suite 330, Boston, MA 02111, USA. *
C *                                                                    *
C **********************************************************************

      SUBROUTINE SETDOM_C(INGX,INGY)
C
C     VERSION(04/23/2013)
C
      INCLUDE 'comdeck'
C
C  TAKE OUT FOUND BOUNDARY CORNER AS IN SETDOM
C        
C
      SAVE

      FSM(INGX,INGY)=0.0
      DUM(INGX,INGY)=0.0
      DVM(INGX,INGY)=0.0
      DUM(INGX+1,JNGY)=0.0
      DVM(INGX,INGY+1)=0.0
      DUMWAD(INGX,INGY)=0.0
      DVMWAD(INGX,INGY)=0.0
      DUMWAD(INGX+1,JNGY)=0.0
      DVMWAD(INGX,INGY+1)=0.0
      COR(INGX,INGY)=0.0
C 
      IF(TOR.NE.'BAROTROPIC') THEN
      DO 350 K=1,KBM1
      AAM(INGX,INGY,K)=0.0
  350 CONTINUE
      AAM2D(INGX,INGY)=0.0
      ELSE
      AAM2D(INGX,INGY)=0.0
      ENDIF
C
      DO 370 K=2,KBM1
      L(INGX,INGY,K)   =0.0
      Q2B(INGX,INGY,K) =0.0
      Q2(INGX,INGY,K)  =0.0
      Q2LB(INGX,INGY,K)=0.0
      Q2L(INGX,INGY,K) =0.0
      KM(INGX,INGY,K)  =0.0
      KQ(INGX,INGY,K)  =0.0
      KH(INGX,INGY,K)  =0.0
  370 CONTINUE
C
C*********************************************************************
C
C
      RETURN
      END 
